using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationLSSCRRYBCK
{
    public class LSSCRRYBCK2021
    {

        public bool ReturnInformationCollectionExists = false;
        public int ReturnInformationCollectionCount = 0;

        /// <summary>
        /// /xbrli:xbrl/:ReturnInformation
        /// LSSCRRYBCK:pyid.02.00:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string LSSCRRYBCK1 = null;

        /// <summary>
        /// /xbrli:xbrl/:ReturnInformation
        /// LSSCRRYBCK:rvctc3.02.xx:Tax.Losses.CarryBackAmendmentReason.Code
        /// </summary>
        public string LSSCRRYBCK2 = null;

        /// <summary>
        /// /xbrli:xbrl/:ReturnInformation
        /// LSSCRRYBCK:rvctc3.02.xx:Tax.AdditionalAmendment.Indicator
        /// </summary>
        public bool? LSSCRRYBCK3 = null;

        /// <summary>
        /// /xbrli:xbrl/:ReturnInformation
        /// LSSCRRYBCK:rvctc3.02.xx:Tax.Losses.CarryBackChangeType.Code
        /// </summary>
        public string LSSCRRYBCK4 = null;

        /// <summary>
        /// /xbrli:xbrl/:ReturnInformation
        /// LSSCRRYBCK:rvctc3.02.31:Tax.AssessmentDifference.Amount
        /// </summary>
        public decimal? LSSCRRYBCK5 = null;

        public bool ReturnInformation_ChoiceYearCollectionExists = false;
        public int ReturnInformation_ChoiceYearCollectionCount = 0;

        public List<ReturnInformation_ChoiceYear> ReturnInformation_ChoiceYearCollection = null;

        public class ReturnInformation_ChoiceYear
        {
            public int OccurrenceIndex = 0;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear
            /// LSSCRRYBCK:pyin.02.37:Report.TargetFinancial.Year
            /// </summary>
            public int? LSSCRRYBCK6 = null;

            public bool ReturnInformation_ChoiceYear_DeductedChangeCollectionExists = false;
            public int ReturnInformation_ChoiceYear_DeductedChangeCollectionCount = 0;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:DeductedChange
            /// LSSCRRYBCK:rvctc3.02.xx:Tax.Losses.CarryBackChangeType.Code
            /// </summary>
            public string LSSCRRYBCK7 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:DeductedChange
            /// LSSCRRYBCK:rvctc3.02.31:Tax.AssessmentDifference.Amount
            /// </summary>
            public decimal? LSSCRRYBCK8 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:DeductedChange
            /// LSSCRRYBCK:rvctc2.02.00:IncomeTax.Deduction.TaxLossesDeducted.Amount
            /// </summary>
            public decimal? LSSCRRYBCK9 = null;

            public bool ReturnInformation_ChoiceYear_OtherAdjustmentsCollectionExists = false;
            public int ReturnInformation_ChoiceYear_OtherAdjustmentsCollectionCount = 0;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:OtherAdjustments
            /// LSSCRRYBCK:rvctc3.02.xx:Tax.AdditionalAdjustment.Indicator
            /// </summary>
            public bool? LSSCRRYBCK10 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:OtherAdjustments
            /// LSSCRRYBCK:rvctc3.02.xx:Tax.Losses.CarryBackChangeType.Code
            /// </summary>
            public string LSSCRRYBCK11 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:OtherAdjustments
            /// LSSCRRYBCK:bafpr1.02.23:Tax.AssessmentDifference.Amount
            /// </summary>
            public decimal? LSSCRRYBCK12 = null;

            public bool ReturnInformation_ChoiceYear_IncomeOrLossChangeCollectionExists = false;
            public int ReturnInformation_ChoiceYear_IncomeOrLossChangeCollectionCount = 0;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:IncomeOrLossChange
            /// LSSCRRYBCK:rvctc3.02.xx:Tax.Losses.CarryBackChangeType.Code
            /// </summary>
            public string LSSCRRYBCK13 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:IncomeOrLossChange
            /// LSSCRRYBCK:rvctc3.02.31:Tax.AssessmentDifference.Amount
            /// </summary>
            public decimal? LSSCRRYBCK14 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:IncomeOrLossChange
            /// LSSCRRYBCK:bafpr1.02.23:Income.Taxable.Amount
            /// </summary>
            public decimal? LSSCRRYBCK15 = null;

            public bool ReturnInformation_ChoiceYear_CarriedForwardChangeCollectionExists = false;
            public int ReturnInformation_ChoiceYear_CarriedForwardChangeCollectionCount = 0;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:CarriedForwardChange
            /// LSSCRRYBCK:rvctc3.02.xx:Tax.Losses.CarryBackChangeType.Code
            /// </summary>
            public string LSSCRRYBCK16 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:CarriedForwardChange
            /// LSSCRRYBCK:rvctc3.02.31:Tax.AssessmentDifference.Amount
            /// </summary>
            public decimal? LSSCRRYBCK17 = null;

            /// <summary>
            /// /xbrli:xbrl/:ReturnInformation/:ChoiceYear/:CarriedForwardChange
            /// LSSCRRYBCK:rvctc3.02.00:Tax.Losses.CarriedForward.Total.Amount
            /// </summary>
            public decimal? LSSCRRYBCK18 = null;
        }

    }
}
